unit ooenet_Client_1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,generalhelpers,
  ooenet,enet;

type

  { TForm1 }

  TForm1 = class(TForm)
   Button1: TButton;
   Button2: TButton;
   Button3: TButton;
   Button4: TButton;
   Button5: TButton;
   Edit1: TEdit;
   Edit2: TEdit;
   Label1: TLabel;
   Label2: TLabel;
   procedure Button1Click(Sender: TObject);
   procedure Button2Click(Sender: TObject);
   procedure Button3Click(Sender: TObject);
   procedure Button4Click(Sender: TObject);
   procedure Button5Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;
  aClient:TEnetClient = nil;
  peer:PENetPeer = nil;
  host:PENetHost = nil;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
var
  aPort:integer = 58000;
begin
aClient :=TEnetClient.create(nil);
if not TryStrtoInt(Edit2.Text,aPort) then aPort := 58000;
if aClient.connect(Edit1.Text,aPort,4000) then
   begin
   ShowMessage('Verbinden: OK');
   Button1.Enabled:= False;
   Button2.Enabled:= False;
   end
  else ShowMessage('Verbinden: FAIL');
end;

procedure TForm1.Button2Click(Sender: TObject);
var ip: ENetAddress;
    event: ENetEvent;
    aPort:integer = 58000;
begin
if not TryStrtoInt(Edit2.Text,aPort) then aPort := 58000;
ip.port:=aPort;
enet_address_set_host(@ip,PChar(Edit1.Text));
host:=enet_host_create(nil, 1, {$IFNDEF ENET12}1,{$ENDIF} 0, 0); // Client-Socket erstellen
peer:=enet_host_connect(host, @ip, {$IFNDEF ENET12}1,{$ENDIF} 0); // mit dem Server verbinden
if enet_host_service(host, @event, 4000) > 0 then
   begin // 6 Sekunden lang verbinden
   if event.typ=ENET_EVENT_TYPE_CONNECT then
      begin // ja er ist drin
      ShowMessage('Verbinden: OK');
      enet_host_flush(host);
      Button1.Enabled:= False;
      Button2.Enabled:= False;
      end
     else ShowMessage('Verbinden: FAIL');
   end
  else ShowMessage('Verbinden: FAIL');
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
if assigned(aClient) then
   begin
   aClient.disconnect;
   FreeAndNil(aClient);
   end;
Button1.Enabled:= True;
Button2.Enabled:= True;
end;

procedure TForm1.Button4Click(Sender: TObject);
var
    s:string;
begin
if InputQuery('Eingabe', 'Was soll verschickt werden', s) then
   begin
   if assigned(aClient) then
      begin
      aClient.send(s,[pfReliable]);
      aClient.flush;
      end;
   if assigned(host) then
      begin
      enet_peer_send_string(peer,s,0);
      enet_host_flush(host);
      end;
   end;
end;

procedure TForm1.Button5Click(Sender: TObject);
var
    i:integer;
    s:string;
begin
s := '.';
for i := 0 to 10000 do s += '.';
if assigned(aClient) then
   begin
   aClient.send(s,[pfReliable]);
   aClient.flush;
   end;
if assigned(host) then
   begin
   enet_peer_send_string(peer,s,0);
   enet_host_flush(host);
   end;
end;

end.

